VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3120
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   5745
   LinkTopic       =   "Form1"
   ScaleHeight     =   208
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   383
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pbFlacPicture 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   3000
      Left            =   60
      ScaleHeight     =   198
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   198
      TabIndex        =   1
      Top             =   60
      Width           =   3000
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Get Info from Flac-File"
      Height          =   555
      Left            =   3150
      TabIndex        =   0
      Top             =   60
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
                        
Private Sub Command1_Click()

    Dim sTag As String
    Dim sTagName As String
    Dim sTagData As String
    Dim sFile As String
    Dim bytData() As Byte
    Dim bolID3 As Boolean
    Dim bolID3v1 As Boolean
    Dim bolID3v2 As Boolean
    Dim bolLastBlock As Boolean
    Dim pInStream As Long
    Dim lSize As Long
    Dim lItem As Long
    Dim lItem2 As Long
    Dim lCount As Long
    Dim lTagEnc As Long
    Dim lBlockLength As Long
    Dim cInStream As clsIStream
    Dim tFLACSTREAM As FLAC_STREAM
    Dim tID3V1HEADER As ID3V1HEADER
    Dim tID3V2HEADER As ID3V2HEADER
    Dim tID3V2FRAMEHEADER As ID3V2FRAMEHEADER
    Dim tFMDB_HEADER As FLAC_METADATA_BLOCK_HEADER
    Dim tFMDB_PADDING As FLAC_METADATA_BLOCK_PADDING
    Dim tFMDB_PICTURE As FLAC_METADATA_BLOCK_PICTURE
    Dim tFMDB_CUESHEET As FLAC_METADATA_BLOCK_CUESHEET
    Dim tFMDB_SEEKTABLE As FLAC_METADATA_BLOCK_SEEKTABLE
    Dim tFMDB_STREAMINFO As FLAC_METADATA_BLOCK_STREAMINFO
    Dim tFMDB_APPLICATION As FLAC_METADATA_BLOCK_APPLICATION
    Dim tFVC_TAGS As FLAC_VORBIS_COMMENT_TAGS
    Dim tFVC_VENDOR As FLAC_VORBIS_COMMENT_VENDOR
    Dim tFVC_VECTOR As FLAC_VORBIS_COMMENT_VECTOR
    
    sFile = App.Path & "\test.flac"
    
    bolID3 = False
    bolID3v1 = False
    bolID3v2 = False
    bolLastBlock = False
    
    If PathFileExistsW(StrPtr(sFile)) = 0& Then
        MsgBox "Flac-Datei'" & sFile & "' nicht gefunden!", vbInformation Or vbOKOnly
        Exit Sub
    End If
    
    ' ein paar kleine Vorbereitungen ausfhren
    Call InitFlacInfo
    
    ' Datei zum lesen ffnen
    If SHCreateStreamOnFileEx(StrPtr(sFile), STGM_READ, 0&, 0&, 0&, _
        pInStream) = S_OK Then
        
        ' IStream Interface
        Set cInStream = New clsIStream
        Call cInStream.Init(pInStream)
        
        ' zum Ende der Datei springen minus Gre des ID3V1HEADER
        ' um den ID3V1HEADER einzulesen
        Call cInStream.Seek_Stream(cInStream.Seek_Stream(0, STREAM_SEEK_END) - _
            LenB(tID3V1HEADER), STREAM_SEEK_SET)
            
        ' ID3V1HEADER einlesen
        Call ReadFromStream(cInStream, VarPtr(tID3V1HEADER), LenB(tID3V1HEADER))
        
        ' ist der ID3V1HEADER Identifier "TAG" vorhanden
        If UCase$(StrCNC(tID3V1HEADER.Tag)) = "TAG" Then
        
            bolID3v1 = True
            
            ' ID3V1-Infos ausgeben
            Debug.Print "Die Flac enthlt einen ID3V1-Block."
            Debug.Print "********************************************"
            Debug.Print "Titel = " & StrCNC(tID3V1HEADER.Id3Fields.Title)
            Debug.Print "Artist = " & StrCNC(tID3V1HEADER.Id3Fields.Artist)
            Debug.Print "Album = " & StrCNC(tID3V1HEADER.Id3Fields.Album)
            Debug.Print "Year = " & StrCNC(tID3V1HEADER.Id3Fields.Year)
            
            If tID3V1HEADER.Id3Fields.Track(0) = 0& Then
                Debug.Print "Comment = " & StrCNC(tID3V1HEADER.Id3Fields.Comment)
            Else
                Debug.Print "Comment = " & StrCNC(tID3V1HEADER.Id3Fields.Comment) & _
                    StrCNC(tID3V1HEADER.Id3Fields.Track)
            End If
            
            If tID3V1HEADER.Id3Fields.Track(0) = 0& Then
                If tID3V1HEADER.Id3Fields.Track(1) <> 0& Then
                    Debug.Print "Track = " & CStr(tID3V1HEADER.Id3Fields.Track(1))
                End If
            End If
            
            If CLng(tID3V1HEADER.Id3Fields.Genre) < m_lGenreUnknown Then
                Debug.Print "Genre = " & m_aGenre(tID3V1HEADER.Id3Fields.Genre)
            Else
                Debug.Print "Genre = " & m_aGenre(m_lGenreUnknown)
            End If
        
        End If
        
        ' zurck zum Anfang der Datei um den ID3v2-Header einzulesen
        Call cInStream.Seek_Stream(0, STREAM_SEEK_SET)
        
        ' ID3V2HEADER einlesen
        Call ReadFromStream(cInStream, VarPtr(tID3V2HEADER), LenB(tID3V2HEADER))
        
        ' ist ein ID3V2HEADER Identifier "ID3" vorhanden
        If UCase$(StrCNC(tID3V2HEADER.Identifier)) = "ID3" Then
        
                bolID3v2 = True
                
                ' ID3V2-Infos ausgeben
                Debug.Print
                Debug.Print "Die Flac enthlt einen ID3V2-Block."
                Debug.Print "********************************************"
                Debug.Print "Version = " & "ID3V2." & CStr(tID3V2HEADER.Version(0)) & _
                    "." & CStr(tID3V2HEADER.Version(1))
                
                ' Simpler ID3V2-Parser. Mit Sicherheit fehlt hier noch einiges bzw
                ' funktioniert noch nicht alles korrekt!!!
                
                ' nur ID3V2.3.x und hher
                If tID3V2HEADER.Version(0) >= 3 Then
                
                    ' alle Tags durchlaufen
                    Do
                    
                        ' ID3V2FRAMEHEADER einlesen
                        Call ReadFromStream(cInStream, VarPtr(tID3V2FRAMEHEADER), _
                            LenB(tID3V2FRAMEHEADER))
                        
                        ' Gre der nachfolgenden Tagdaten ermitteln
                        lSize = GetSizeLong(tID3V2FRAMEHEADER.Size)
                        
                        ' sind Daten vorhanden
                        If lSize <> 0 Then
                            
                            sTagName = StrConv(tID3V2FRAMEHEADER.ID, vbUnicode)
                            
                            ' zuerst das Textencoding auslesen
                            ReDim bytData(0 To 0)
                            Call ReadFromStream(cInStream, VarPtr(bytData(0)), 1)
                            lSize = lSize - 1
                            
                            ' Textencoding speichern
                            lTagEnc = bytData(0)
                            
                            ' nur die Textencoding 0 bis 3
                            If lTagEnc >= 0 And lTagEnc <= 3 Then
                                
                                ' nach Textencoding selektieren
                                Select Case lTagEnc
                                Case 0 ' ASCII
                                    
                                    ' Rest auslesen
                                    ReDim bytData(lSize - 1)
                                    Call ReadFromStream(cInStream, VarPtr(bytData(0)), lSize)
                                    sTagData = StrConv(bytData, vbUnicode)
                                
                                Case 1 ' UTF-16 encoded Unicode with BOM, in ID3v2.2 and ID3v2.3.
                                       
                                    ' BOM auslesen
                                    ReDim bytData(0 To 1)
                                    Call ReadFromStream(cInStream, VarPtr(bytData(0)), 2)
                                    lSize = lSize - 2
                                    
                                    ' FF FE    UTF-16, little endian
                                    If bytData(0) = &HFF& And bytData(1) = &HFE& Then
                                    
                                        ' Rest auslesen
                                        ReDim bytData(lSize - 1)
                                        Call ReadFromStream(cInStream, VarPtr(bytData(0)), lSize)
                                        sTagData = ConvertFrom(bytData, CP_UTF16_LE)
                                    
                                    Else
                                    
                                        ' FE FF    UTF-16, big endian
                                    
                                        ' Rest auslesen
                                        ReDim bytData(lSize - 1)
                                        Call ReadFromStream(cInStream, VarPtr(bytData(0)), lSize)
                                        sTagData = ConvertFrom(bytData, CP_UTF16_BE)
                                    
                                    End If
                                       
                                Case 2 ' UTF-16BE encoded Unicode without BOM, in ID3v2.4
                                        
                                    ' Rest auslesen
                                    ReDim bytData(lSize - 1)
                                    Call ReadFromStream(cInStream, VarPtr(bytData(0)), lSize)
                                    sTagData = ConvertFrom(bytData, CP_UTF16_BE)
                                        
                                Case 3 ' UTF-8 encoded Unicode, in ID3v2.4
                                    
                                    ' Rest auslesen
                                    ReDim bytData(lSize - 1)
                                    Call ReadFromStream(cInStream, VarPtr(bytData(0)), lSize)
                                    sTagData = ConvertFrom(bytData, CP_UTF8)
                                
                                End Select
                                
                            End If
                            
                            Debug.Print sTagName & " = " & sTagData
                            
                        End If
                    
                    ' Schleife verlassen wenn die Gre der Tagdaten = 0 ist
                    Loop Until lSize = 0&
                
                End If
                
                ' an das Ende vom ID3V2-Block springen
                Call cInStream.Seek_Stream(LenB(tID3V2HEADER) + _
                    GetID3V2DataSize(tID3V2HEADER.Size), STREAM_SEEK_SET)
        
        Else
            
                ' ansonsten zurck zum Anfang der Datei
                Call cInStream.Seek_Stream(0, STREAM_SEEK_SET)
            
        End If
        
        ' FLACSTREAM einlesen
        Call ReadFromStream(cInStream, VarPtr(tFLACSTREAM), LenB(tFLACSTREAM))
        
        ' ist ein FLACSTREAM Identifier "flaC" vorhanden
        If UCase$(StrCNC(tFLACSTREAM.Stream)) = "FLAC" Then
        
            ' alle Flac-Header durchlaufen
            Do
            
                ' FLACMETADATABLOCKHEADER einlesen
                Call ReadFromStream(cInStream, VarPtr(tFMDB_HEADER), _
                    LenB(tFMDB_HEADER))
                    
                ' ist es der letzte Block
                If CBool(tFMDB_HEADER.BlockType And &H80&) = True Then
                    
                    ' Schleife verlassen, da letzter Block
                    bolLastBlock = True
                    
                    Debug.Print
                    Debug.Print
                    Debug.Print "----==== This is the last block ====----"
                    
                End If
                
                ' Gre des Blocks ermitteln
                lBlockLength = GetSizeLong(tFMDB_HEADER.BlockLength)
                
                ' nach Blocktyp selektieren
                Select Case tFMDB_HEADER.BlockType And Not &H80&
                
                Case 0 ' STREAMINFO
                
                    Debug.Print
                    Debug.Print "Flac STREAMINFO"
                    Debug.Print "********************************************"
                    
                    ' METADATA_BLOCK_STREAMINFO einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_STREAMINFO), lBlockLength)
                    
                    ' Sample rate in Hz
                    Debug.Print "Sample rate = " & CStr(GetFlacSampleRate(tFMDB_STREAMINFO.SrChBpsTotal)) & "Hz"

                    ' Number of channels
                    Debug.Print "Number of channels = " & CStr(GetFlacChannels(tFMDB_STREAMINFO.SrChBpsTotal)) & "Ch"

                    ' Bits per sample
                    Debug.Print "Bits per sample = " & CStr(GetFlacBitsPerSample(tFMDB_STREAMINFO.SrChBpsTotal)) & "bit"
                    
                    ' Total samples in stream
                    Debug.Print "Total samples in stream = " & CStr(GetFlacTotalSample(tFMDB_STREAMINFO.SrChBpsTotal))
                    
                    ' Duration in sec = Total samples in stream / Sample rate
                    Debug.Print "Duration = " & Sek2HMS(GetFlacTotalSample(tFMDB_STREAMINFO.SrChBpsTotal) \ _
                                                        GetFlacSampleRate(tFMDB_STREAMINFO.SrChBpsTotal))
                   
                    Debug.Print "MinBlockSize = " & CStr(GetSizeLong(tFMDB_STREAMINFO.MinBlockSize))
                    Debug.Print "MaxBlockSize = " & CStr(GetSizeLong(tFMDB_STREAMINFO.MaxBlockSize))
                    Debug.Print "MinFrameSize = " & CStr(GetSizeLong(tFMDB_STREAMINFO.MinFrameSize))
                    Debug.Print "MaxFrameSize = " & CStr(GetSizeLong(tFMDB_STREAMINFO.MaxFrameSize))
                
                Case 1 ' PADDING
                     
                    Debug.Print
                    Debug.Print "Flac PADDING"
                    Debug.Print "********************************************"
                    
                    ' Padding-Block einlesen
                    ReDim tFMDB_PADDING.Padding(lBlockLength - 1)
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PADDING.Padding(0)), lBlockLength)
                    Debug.Print "Size of paddingdata = " & CStr(lBlockLength) & " Bytes"

               Case 2 ' APPLICATION
                    Debug.Print
                    Debug.Print "Flac APPLICATION"
                    Debug.Print "********************************************"
                    
                    ' Application-Block einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_APPLICATION.AppID(0)), 4)
                    Debug.Print "ApplicationID = " & StrCNC(tFMDB_APPLICATION.AppID)
                    
                    ' gibt es Daten
                    If lBlockLength - 5 >= 0 Then
                        ReDim tFMDB_APPLICATION.AppData(lBlockLength - 5)
                        Call ReadFromStream(cInStream, VarPtr(tFMDB_APPLICATION.AppData(0)), lBlockLength - 4)
                        Debug.Print "ApplicationData = " & StrCNC(tFMDB_APPLICATION.AppData)
                    End If
                    
                Case 3 ' SEEKTABLE
                    Debug.Print
                    Debug.Print "Flac SEEKTABLE"
                    Debug.Print "********************************************"
                    
                    ' SeekTablePoints einlesen
                    lCount = lBlockLength / 18
                    
                    ' sind Daten vorhanden
                    If lCount > 0& Then
                    
                        ' SEEKPOINT dimensionieren und einlesen
                        ReDim tFMDB_SEEKTABLE.tSEEKPOINT(lCount - 1)
                        Call ReadFromStream(cInStream, VarPtr(tFMDB_SEEKTABLE.tSEEKPOINT(0)), _
                            LenB(tFMDB_SEEKTABLE.tSEEKPOINT(0)) * lCount)
                        
                        Debug.Print "SeekTablePoints = " & CStr(lCount)
                        
                        ' alle SEEKPOINT durchlaufen
                        For lItem = 0 To lCount - 1
                            Debug.Print "SeekPoint " & CStr(lItem + 1)
                            Debug.Print vbTab & "SampleNumber = " & CStr(GetSizeDouble(tFMDB_SEEKTABLE.tSEEKPOINT(lItem).SampleNumber))
                            Debug.Print vbTab & "Offset = " & CStr(GetSizeDouble(tFMDB_SEEKTABLE.tSEEKPOINT(lItem).Offset))
                            Debug.Print vbTab & "NumberOfSample = " & CStr(GetSizeLong(tFMDB_SEEKTABLE.tSEEKPOINT(lItem).NumberOfSample))
                        Next
                    
                    End If
                
                Case 4 ' VORBIS_COMMENT
                
                    Debug.Print
                    Debug.Print "Flac VORBIS_COMMENT"
                    Debug.Print "********************************************"
                
                    ' zuerst die VendorLength und den VendorString einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFVC_VENDOR.VendorLength(0)), 4)
                    Call CopyMemory(lSize, tFVC_VENDOR.VendorLength(0), 4)
                    ReDim tFVC_VENDOR.VendorString(lSize - 1)
                    Call ReadFromStream(cInStream, VarPtr(tFVC_VENDOR.VendorString(0)), lSize)
                    Debug.Print "VendorID = " & ConvertFrom(tFVC_VENDOR.VendorString, CP_UTF8)
                        
                    ' dann den Tags-Count einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFVC_TAGS.Count(0)), 4)
                    Call CopyMemory(lCount, tFVC_TAGS.Count(0), 4)
                    
                    ' sind Daten vorhanden
                    If lCount > 0& Then
                        
                        ' alle Tags durchlaufen
                        For lItem = 0 To lCount - 1
                    
                            ' den VectorLength und den VectorString einlesen
                            Call ReadFromStream(cInStream, VarPtr(tFVC_VECTOR.VectorLength(0)), 4)
                            Call CopyMemory(lSize, tFVC_VECTOR.VectorLength(0), 4)
                            ReDim tFVC_VECTOR.VectorString(lSize - 1)
                            Call ReadFromStream(cInStream, VarPtr(tFVC_VECTOR.VectorString(0)), lSize)
                            sTag = ConvertFrom(tFVC_VECTOR.VectorString, CP_UTF8)
                        
                            lSize = InStr(1, sTag, "=")
                        
                            If lSize > 0& Then
                                sTagName = Mid$(sTag, 1, lSize - 1)
                                sTagData = Mid$(sTag, lSize + 1)
                                Debug.Print sTagName & " = " & sTagData
                            End If
                        
                        Next
                        
                    End If
                    
                Case 5 ' CUESHEET
                    
                    Debug.Print
                    Debug.Print "Flac CUESHEET"
                    Debug.Print "********************************************"
                    
                    ' METADATA_BLOCK_CUESHEET einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.MediaCatalogNumber(0)), 128)
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.NumberOfLeadInSamples(0)), 8)
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.CorrespondsToCDRes(0)), 259)
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.NumberOfTracks), 1)
                    Debug.Print "CUESHEET.MediaCatalogNumber = " & StrCNC(tFMDB_CUESHEET.MediaCatalogNumber)
                    Debug.Print "CUESHEET.NumberOfLeadInSamples = " & CStr(GetSizeDouble(tFMDB_CUESHEET.NumberOfLeadInSamples))
                    
                    If CBool(tFMDB_CUESHEET.CorrespondsToCDRes(0) And &H80&) = True Then
                        Debug.Print "CUESHEET corresponds to a Compact Disc"
                    End If
                    Debug.Print "CUESHEET.NumberOfTracks = " & CStr(tFMDB_CUESHEET.NumberOfTracks)
                    
                    ' sind CUESHEET_TRACK vorhanden
                    If tFMDB_CUESHEET.NumberOfTracks > 0& Then
                        
                        ' alle CUESHEET_TRACK durchlaufen
                        For lItem = 0 To tFMDB_CUESHEET.NumberOfTracks - 1
                        
                            Debug.Print vbTab & "CUESHEET_TRACK " & CStr(lItem + 1)
                            Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackOffset(0)), 8)
                            Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackNumber), 1)
                            Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackISRC(0)), 12)
                            Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackTypePreEmphasisFlagRes(0)), 14)
                            Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.NumberOfTrackIndex), 1)
                            Debug.Print vbTab & "CUESHEET_TRACK.TrackOffset = " & CStr(GetSizeDouble(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackOffset))
                            Debug.Print vbTab & "CUESHEET_TRACK.TrackNumber = " & CStr(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackNumber)
                            Debug.Print vbTab & "CUESHEET_TRACK.TrackISRC = " & StrConv(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackISRC, vbUnicode)
                            Debug.Print vbTab & "CUESHEET_TRACK.NumberOfTrackIndex = " & CStr(tFMDB_CUESHEET.tCUESHEET_TRACK.NumberOfTrackIndex)
                            
                            Select Case tFMDB_CUESHEET.tCUESHEET_TRACK.TrackNumber
                            Case 1 To 99
                                Debug.Print vbTab & "* Track lead-in"
                            Case 170, 255
                                Debug.Print vbTab & "* Track lead-out"
                            End Select
                            
                            If CBool(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackTypePreEmphasisFlagRes(0) And &H80&) = True Then
                                Debug.Print vbTab & "* The track type: 1 for non-audio"
                            Else
                                Debug.Print vbTab & "* The track type: 0 for audio"
                            End If
                            
                            If CBool(tFMDB_CUESHEET.tCUESHEET_TRACK.TrackTypePreEmphasisFlagRes(0) And &H40&) = True Then
                                Debug.Print vbTab & "* The pre-emphasis flag: 1 for pre-emphasis"
                            Else
                                Debug.Print vbTab & "* The pre-emphasis flag: 0 for no pre-emphasis"
                            End If
                        
                            ' sind CUESHEET_TRACK_INDEX vorhanden
                            If tFMDB_CUESHEET.tCUESHEET_TRACK.NumberOfTrackIndex > 0& Then
                                
                                ' alle CUESHEET_TRACK_INDEX durchlaufen
                                For lItem2 = 0 To tFMDB_CUESHEET.tCUESHEET_TRACK.NumberOfTrackIndex - 1
                                
                                    Debug.Print vbTab & vbTab & "CUESHEET_TRACK_INDEX " & CStr(lItem2 + 1)
                                    Call ReadFromStream(cInStream, VarPtr(tFMDB_CUESHEET.tCUESHEET_TRACK.tCUESHEET_TRACK_INDEX), 12)
                                    Debug.Print vbTab & vbTab & "CUESHEET_TRACK_INDEX.OffsetInSamples = " & _
                                        CStr(GetSizeDouble(tFMDB_CUESHEET.tCUESHEET_TRACK.tCUESHEET_TRACK_INDEX.OffsetInSamples))
                                    Debug.Print vbTab & vbTab & "CUESHEET_TRACK_INDEX.IndexPointNumber = " & _
                                        CStr(tFMDB_CUESHEET.tCUESHEET_TRACK.tCUESHEET_TRACK_INDEX.IndexPointNumber)
                                Next
                                
                            End If
                            
                        Next
                        
                    End If
                    
                Case 6 ' PICTURE
                    
                    Debug.Print
                    Debug.Print "Flac PICTURE"
                    Debug.Print "********************************************"
                    
                    ' Zuerst den Type einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.PicType(0)), 4)
                    Select Case GetSizeLong(tFMDB_PICTURE.PicType)
                    Case 0: Debug.Print "Other"
                    Case 1: Debug.Print "32x32 pixels 'file icon' (PNG only)"
                    Case 2: Debug.Print "Other file icon"
                    Case 3: Debug.Print "Cover(front)"
                    Case 4: Debug.Print "Cover(back)"
                    Case 5: Debug.Print "Leaflet page"
                    Case 6: Debug.Print "Media (e.g. label side of CD)"
                    Case 7: Debug.Print "Lead artist/lead performer/soloist"
                    Case 8: Debug.Print "Artist / performer"
                    Case 9: Debug.Print "Conductor"
                    Case 10: Debug.Print "Band / Orchestra"
                    Case 11: Debug.Print "Composer"
                    Case 12: Debug.Print "Lyricist/text writer"
                    Case 13: Debug.Print "Recording Location"
                    Case 14: Debug.Print "During recording"
                    Case 15: Debug.Print "During performance"
                    Case 16: Debug.Print "Movie/video screen capture"
                    Case 17: Debug.Print "A bright coloured fish"
                    Case 18: Debug.Print "Illustration"
                    Case 19: Debug.Print "Band/artist logotype"
                    Case 20: Debug.Print "Publisher/Studio logotype"
                    End Select
                    
                    ' dann die MimeTypeLength und den MimeTypeString einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.MimeTypeLength(0)), 4)
                    lSize = GetSizeLong(tFMDB_PICTURE.MimeTypeLength)
                    
                    If lSize > 0& Then
                        ReDim tFMDB_PICTURE.MimeTypeString(lSize - 1)
                        Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.MimeTypeString(0)), lSize)
                        Debug.Print "MimeType = " & StrConv(tFMDB_PICTURE.MimeTypeString, vbUnicode)
                    End If
                    
                    ' dann die DescriptionLength und den DescriptionString einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.DescriptionLength(0)), 4)
                    lSize = GetSizeLong(tFMDB_PICTURE.DescriptionLength)
                    
                    If lSize > 0& Then
                        ReDim tFMDB_PICTURE.DescriptionString(lSize - 1)
                        Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.DescriptionString(0)), lSize)
                        Debug.Print "Description = " & StrConv(tFMDB_PICTURE.DescriptionString, vbUnicode)
                    End If
                    
                    ' dann die PicWidth einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.PicWidth(0)), 4)
                    
                    If GetSizeLong(tFMDB_PICTURE.PicWidth) > 0& Then
                        Debug.Print "PicWidth = " & CStr(GetSizeLong(tFMDB_PICTURE.PicWidth))
                    End If
                    
                    ' dann die PicHeight einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.PicHeight(0)), 4)
                    
                    If GetSizeLong(tFMDB_PICTURE.PicHeight) > 0& Then
                        Debug.Print "PicHeight = " & CStr(GetSizeLong(tFMDB_PICTURE.PicHeight))
                    End If
                    
                    ' dann die ColorDepth einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.ColorDepth(0)), 4)
                    
                    If GetSizeLong(tFMDB_PICTURE.ColorDepth) > 0& Then
                        Debug.Print "ColorDepth = " & CStr(GetSizeLong(tFMDB_PICTURE.ColorDepth))
                    End If
                    
                    ' dann die ColorOfUsed einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.ColorOfUsed(0)), 4)
                    
                    If GetSizeLong(tFMDB_PICTURE.ColorOfUsed) > 0& Then
                        Debug.Print "ColorOfUsed = " & CStr(GetSizeLong(tFMDB_PICTURE.ColorOfUsed))
                    End If
                    
                    ' und zuletzt die PicDataLength und den PicDataBinary einlesen
                    Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.PicDataLength(0)), 4)
                    lSize = GetSizeLong(tFMDB_PICTURE.PicDataLength)
                    
                    If lSize > 0& Then
                        Debug.Print "Size of picdata = " & CStr(lSize) & " Bytes"
                        ReDim tFMDB_PICTURE.PicDataBinary(lSize - 1)
                        Call ReadFromStream(cInStream, VarPtr(tFMDB_PICTURE.PicDataBinary(0)), lSize)
                        Call pbFlacPicture.PaintPicture(GetPicture(tFMDB_PICTURE.PicDataBinary), 0, 0, 200, 200)
                    End If
                                                                     
                Case 7 To 127 ' diese Blcke berspringen
                
                    Call cInStream.Seek_Stream(cInStream.Seek_Stream(0, _
                        STREAM_SEEK_CUR) + lBlockLength, STREAM_SEEK_SET)
                        
                End Select
                
                
            ' Schleife so lange durchlaufen bis der letzte Block erreicht wurde
            Loop Until bolLastBlock = True
            
        End If
        
        ' Zugriff auf die Datei schlieen
        Set cInStream = Nothing
        
    End If
    
End Sub
